Overview | Package | Class | Tree | Deprecated | Index | Help
| Spring Framework
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.springframework.jms.connection
Class JmsTransactionManager

    java.lang.Object
      org.springframework.transaction.support.AbstractPlatformTransactionManager
          org.springframework.jms.connection.JmsTransactionManager

All Implemented Interfaces:
  java.io.Serializable, InitializingBean, PlatformTransactionManager, ResourceTransactionManager

Direct Known Subclasses:
  JmsTransactionManager102

    public class JmsTransactionManager

extends AbstractPlatformTransactionManager
implements ResourceTransactionManager, InitializingBean

`PlatformTransactionManager` implementation for a single JMS `ConnectionFactory`. Binds a JMS Connection/Session pair from the specified ConnectionFactory to the thread, potentially allowing for one thread-bound Session per ConnectionFactory.

This local strategy is an alternative to executing JMS operations within JTA transactions. Its advantage is that it is able to work in any environment, for example a standalone application or a test suite, with any message broker as target. However, this strategy is not able to provide XA transactions, for example in order to share transactions between messaging and database access. A full JTA/XA setup is required for XA transactions, typically using Spring's `JtaTransactionManager` as strategy.

Application code is required to retrieve the transactional JMS Session via `ConnectionFactoryUtils.getTransactionalSession(javax.jms.ConnectionFactory, javax.jms.Connection, boolean)` instead of a standard J2EE-style `ConnectionFactory.createConnection()` call with subsequent Session creation. Spring's `JmsTemplate` will autodetect a thread-bound Session and automatically participate in it.

Alternatively, you can allow application code to work with the standard J2EE-style lookup pattern on a ConnectionFactory, for example for legacy code that is not aware of Spring at all. In that case, define a `TransactionAwareConnectionFactoryProxy` for your target ConnectionFactory, which will automatically participate in Spring-managed transactions.

The use of `CachingConnectionFactory` as a target for this transaction manager is strongly recommended. CachingConnectionFactory uses a single JMS Connection for all JMS access in order to avoid the overhead of repeated Connection creation, as well as maintaining a cache of Sessions. Each transaction will then share the same JMS Connection, while still using its own individual JMS Session.

The use of a raw target ConnectionFactory would not only be inefficient because of the lack of resource reuse. It might also lead to strange effects when your JMS driver doesn't accept `MessageProducer.close()` calls and/or `MessageConsumer.close()` calls before `Session.commit()`, with the latter supposed to commit all the messages that have been sent through the producer handle and received through the consumer handle. As a safe general solution, always pass in a `CachingConnectionFactory` into this transaction manager's `"connectionFactory"` property.

Transaction synchronization is turned off by default, as this manager might be used alongside a datastore-based Spring transaction manager such as the JDBC `DataSourceTransactionManager`, which has stronger needs for synchronization.

Since:
  1.1
Author:
  Juergen Hoeller
See Also:
  `ConnectionFactoryUtils.getTransactionalSession(javax.jms.ConnectionFactory, javax.jms.Connection, boolean)`, `TransactionAwareConnectionFactoryProxy`, `JmsTemplate`, Serialized Form

Nested Class Summary

Nested classes/interfaces inherited from class org.springframework.transaction.support.AbstractPlatformTransactionManager
`AbstractPlatformTransactionManager.SuspendedResourcesHolder`

Field Summary

Fields inherited from class org.springframework.transaction.support.AbstractPlatformTransactionManager
`logger, SYNCHRONIZATION_ALWAYS, SYNCHRONIZATION_NEVER, SYNCHRONIZATION_ON_ACTUAL_TRANSACTION`

Constructor Summary
`JmsTransactionManager()` Create a new JmsTransactionManager for bean-style usage.
`JmsTransactionManager(javax.jms.ConnectionFactory connectionFactory)` Create a new JmsTransactionManager, given a ConnectionFactory.

Method Summary
`void` | `afterPropertiesSet()` Make sure the ConnectionFactory has been set.
`protected javax.jms.Connection` | `createConnection()` Create a JMS Connection via this template's ConnectionFactory.
`protected javax.jms.Session` | `createSession(javax.jms.Connection con)` Create a JMS Session for the given Connection.
`protected void` | `doBegin(java.lang.Object transaction, TransactionDefinition definition)` Begin a new transaction with semantics according to the given transaction definition.
`protected void` | `doCleanupAfterCompletion(java.lang.Object transaction)` Cleanup resources after transaction completion.
`protected void` | `doCommit(DefaultTransactionStatus status)` Perform an actual commit of the given transaction.
`protected java.lang.Object` | `doGetTransaction()` Return a transaction object for the current transaction state.
`protected void` | `doResume(java.lang.Object transaction, java.lang.Object suspendedResources)` Resume the resources of the current transaction.
`protected void` | `doRollback(DefaultTransactionStatus status)` Perform an actual rollback of the given transaction.
`protected void` | `doSetRollbackOnly(DefaultTransactionStatus status)` Set the given transaction rollback-only.
`protected java.lang.Object` | `doSuspend(java.lang.Object transaction)` Suspend the resources of the current transaction.
`javax.jms.ConnectionFactory` | `getConnectionFactory()` Return the JMS ConnectionFactory that this instance should manage transactions for.
`java.lang.Object` | `getResourceFactory()` Return the resource factory that this transaction manager operates on, e.g.
`protected boolean` | `isExistingTransaction(java.lang.Object transaction)` Check if the given transaction object indicates an existing transaction (that is, a transaction which has already started).
`void` | `setConnectionFactory(javax.jms.ConnectionFactory cf)` Set the JMS ConnectionFactory that this instance should manage transactions for.

Methods inherited from class org.springframework.transaction.support.AbstractPlatformTransactionManager
`commit, determineTimeout, getDefaultTimeout, getTransaction, getTransactionSynchronization, invokeAfterCompletion, isFailEarlyOnGlobalRollbackOnly, isGlobalRollbackOnParticipationFailure, isNestedTransactionAllowed, isRollbackOnCommitFailure, isValidateExistingTransaction, newTransactionStatus, prepareForCommit, prepareSynchronization, prepareTransactionStatus, registerAfterCompletionWithExistingTransaction, resume, rollback, setDefaultTimeout, setFailEarlyOnGlobalRollbackOnly, setGlobalRollbackOnParticipationFailure, setNestedTransactionAllowed, setRollbackOnCommitFailure, setTransactionSynchronization, setTransactionSynchronizationName, setValidateExistingTransaction, shouldCommitOnGlobalRollbackOnly, suspend, triggerBeforeCommit, triggerBeforeCompletion, useSavepointForNestedTransaction`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface org.springframework.transaction.PlatformTransactionManager
`commit, getTransaction, rollback`

Constructor Detail

### JmsTransactionManager

    public JmsTransactionManager()

  Create a new JmsTransactionManager for bean-style usage.

  Note: The ConnectionFactory has to be set before using the instance. This constructor can be used to prepare a JmsTemplate via a BeanFactory, typically setting the ConnectionFactory via setConnectionFactory.

  Turns off transaction synchronization by default, as this manager might be used alongside a datastore-based Spring transaction manager like DataSourceTransactionManager, which has stronger needs for synchronization. Only one manager is allowed to drive synchronization at any point of time.

  See Also:
    `setConnectionFactory(javax.jms.ConnectionFactory)`, `AbstractPlatformTransactionManager.setTransactionSynchronization(int)`

### JmsTransactionManager

    public JmsTransactionManager(javax.jms.ConnectionFactory connectionFactory)

  Create a new JmsTransactionManager, given a ConnectionFactory.

  Parameters:
    `connectionFactory` - the ConnectionFactory to obtain connections from

Method Detail

### setConnectionFactory

    public void setConnectionFactory(javax.jms.ConnectionFactory cf)

  Set the JMS ConnectionFactory that this instance should manage transactions for.

### getConnectionFactory

    public javax.jms.ConnectionFactory getConnectionFactory()

  Return the JMS ConnectionFactory that this instance should manage transactions for.

### afterPropertiesSet

    public void afterPropertiesSet()

  Make sure the ConnectionFactory has been set.

  Specified by:
    `afterPropertiesSet` in interface `InitializingBean`

### getResourceFactory

    public java.lang.Object getResourceFactory()

  Description copied from interface: `ResourceTransactionManager`
  Return the resource factory that this transaction manager operates on, e.g. a JDBC DataSource or a JMS ConnectionFactory.

  This target resource factory is usually used as resource key for `TransactionSynchronizationManager`'s resource bindings per thread.

  Specified by:
    `getResourceFactory` in interface `ResourceTransactionManager`
  Returns:
    the target resource factory (never `null`)
  See Also:
    `TransactionSynchronizationManager.bindResource(java.lang.Object, java.lang.Object)`, `TransactionSynchronizationManager.getResource(java.lang.Object)`

### doGetTransaction

    protected java.lang.Object doGetTransaction()

  Description copied from class: `AbstractPlatformTransactionManager`
  Return a transaction object for the current transaction state.

  The returned object will usually be specific to the concrete transaction manager implementation, carrying corresponding transaction state in a modifiable fashion. This object will be passed into the other template methods (e.g. doBegin and doCommit), either directly or as part of a DefaultTransactionStatus instance.

  The returned object should contain information about any existing transaction, that is, a transaction that has already started before the current `getTransaction` call on the transaction manager. Consequently, a `doGetTransaction` implementation will usually look for an existing transaction and store corresponding state in the returned transaction object.

  Specified by:
    `doGetTransaction` in class `AbstractPlatformTransactionManager`
  Returns:
    the current transaction object
  See Also:
    `AbstractPlatformTransactionManager.doBegin(java.lang.Object, org.springframework.transaction.TransactionDefinition)`, `AbstractPlatformTransactionManager.doCommit(org.springframework.transaction.support.DefaultTransactionStatus)`, `AbstractPlatformTransactionManager.doRollback(org.springframework.transaction.support.DefaultTransactionStatus)`, `DefaultTransactionStatus.getTransaction()`

### isExistingTransaction

    protected boolean isExistingTransaction(java.lang.Object transaction)

  Description copied from class: `AbstractPlatformTransactionManager`
  Check if the given transaction object indicates an existing transaction (that is, a transaction which has already started).

  The result will be evaluated according to the specified propagation behavior for the new transaction. An existing transaction might get suspended (in case of PROPAGATION_REQUIRES_NEW), or the new transaction might participate in the existing one (in case of PROPAGATION_REQUIRED).

  The default implementation returns `false`, assuming that participating in existing transactions is generally not supported. Subclasses are of course encouraged to provide such support.

  Overrides:
    `isExistingTransaction` in class `AbstractPlatformTransactionManager`
  Parameters:
    `transaction` - transaction object returned by doGetTransaction
  Returns:
    if there is an existing transaction
  See Also:
    `AbstractPlatformTransactionManager.doGetTransaction()`

### doBegin

    protected void doBegin(java.lang.Object transaction,
                           TransactionDefinition definition)

  Description copied from class: `AbstractPlatformTransactionManager`
  Begin a new transaction with semantics according to the given transaction definition. Does not have to care about applying the propagation behavior, as this has already been handled by this abstract manager.

  This method gets called when the transaction manager has decided to actually start a new transaction. Either there wasn't any transaction before, or the previous transaction has been suspended.

  A special scenario is a nested transaction without savepoint: If `useSavepointForNestedTransaction()` returns "false", this method will be called to start a nested transaction when necessary. In such a context, there will be an active transaction: The implementation of this method has to detect this and start an appropriate nested transaction.

  Specified by:
    `doBegin` in class `AbstractPlatformTransactionManager`
  Parameters:
    `transaction` - transaction object returned by `doGetTransaction`
    `definition` - TransactionDefinition instance, describing propagation behavior, isolation level, read-only flag, timeout, and transaction name

### doSuspend

    protected java.lang.Object doSuspend(java.lang.Object transaction)

  Description copied from class: `AbstractPlatformTransactionManager`
  Suspend the resources of the current transaction. Transaction synchronization will already have been suspended.

  The default implementation throws a TransactionSuspensionNotSupportedException, assuming that transaction suspension is generally not supported.

  Overrides:
    `doSuspend` in class `AbstractPlatformTransactionManager`
  Parameters:
    `transaction` - transaction object returned by `doGetTransaction`
  Returns:
    an object that holds suspended resources (will be kept unexamined for passing it into doResume)
  See Also:
    `AbstractPlatformTransactionManager.doResume(java.lang.Object, java.lang.Object)`

### doResume

    protected void doResume(java.lang.Object transaction,
                            java.lang.Object suspendedResources)

  Description copied from class: `AbstractPlatformTransactionManager`
  Resume the resources of the current transaction. Transaction synchronization will be resumed afterwards.

  The default implementation throws a TransactionSuspensionNotSupportedException, assuming that transaction suspension is generally not supported.

  Overrides:
    `doResume` in class `AbstractPlatformTransactionManager`
  Parameters:
    `transaction` - transaction object returned by `doGetTransaction`
    `suspendedResources` - the object that holds suspended resources, as returned by doSuspend
  See Also:
    `AbstractPlatformTransactionManager.doSuspend(java.lang.Object)`

### doCommit

    protected void doCommit(DefaultTransactionStatus status)

  Description copied from class: `AbstractPlatformTransactionManager`
  Perform an actual commit of the given transaction.

  An implementation does not need to check the "new transaction" flag or the rollback-only flag; this will already have been handled before. Usually, a straight commit will be performed on the transaction object contained in the passed-in status.

  Specified by:
    `doCommit` in class `AbstractPlatformTransactionManager`
  Parameters:
    `status` - the status representation of the transaction
  See Also:
    `DefaultTransactionStatus.getTransaction()`

### doRollback

    protected void doRollback(DefaultTransactionStatus status)

  Description copied from class: `AbstractPlatformTransactionManager`
  Perform an actual rollback of the given transaction.

  An implementation does not need to check the "new transaction" flag; this will already have been handled before. Usually, a straight rollback will be performed on the transaction object contained in the passed-in status.

  Specified by:
    `doRollback` in class `AbstractPlatformTransactionManager`
  Parameters:
    `status` - the status representation of the transaction
  See Also:
    `DefaultTransactionStatus.getTransaction()`

### doSetRollbackOnly

    protected void doSetRollbackOnly(DefaultTransactionStatus status)

  Description copied from class: `AbstractPlatformTransactionManager`
  Set the given transaction rollback-only. Only called on rollback if the current transaction participates in an existing one.

  The default implementation throws an IllegalTransactionStateException, assuming that participating in existing transactions is generally not supported. Subclasses are of course encouraged to provide such support.

  Overrides:
    `doSetRollbackOnly` in class `AbstractPlatformTransactionManager`
  Parameters:
    `status` - the status representation of the transaction

### doCleanupAfterCompletion

    protected void doCleanupAfterCompletion(java.lang.Object transaction)

  Description copied from class: `AbstractPlatformTransactionManager`
  Cleanup resources after transaction completion.

  Called after `doCommit` and `doRollback` execution, on any outcome. The default implementation does nothing.

  Should not throw any exceptions but just issue warnings on errors.

  Overrides:
    `doCleanupAfterCompletion` in class `AbstractPlatformTransactionManager`
  Parameters:
    `transaction` - transaction object returned by `doGetTransaction`

### createConnection

    protected javax.jms.Connection createConnection()
                                             throws javax.jms.JMSException

  Create a JMS Connection via this template's ConnectionFactory.

  This implementation uses JMS 1.1 API.

  Returns:
    the new JMS Connection
  Throws:
    `javax.jms.JMSException` - if thrown by JMS API methods

### createSession

    protected javax.jms.Session createSession(javax.jms.Connection con)
                                       throws javax.jms.JMSException

  Create a JMS Session for the given Connection.

  This implementation uses JMS 1.1 API.

  Parameters:
    `con` - the JMS Connection to create a Session for
  Returns:
    the new JMS Session
  Throws:
    `javax.jms.JMSException` - if thrown by JMS API methods

Overview | Package | Class | Tree | Deprecated | Index | Help
| Spring Framework
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD